<?
//  
//  Copyright (c) 2006, 2007		Dmitry Butskoy
//  					<buc@citadel.stu.neva.ru>
//  License:  GPL v2 or any later
//  
//  For full terms see the file COPYING.
//  


function canon_lang($ll) {

	$l = explode("-", $ll);
	if (sizeof($l) == 2)
		return  strtolower($l[0]) . "_" . strtoupper($l[1]);

	$str = strtolower($l[0]);
	if ($str == "ja")  $str .= "_JP";
	else  $str .= "_" . strtoupper($str);

	return $str;
}


function wmlstart($cache = 0) {
    global $H,$F,$U,$CP,$S;

    //  First, set appropriate HTTP headers
    header("Content-type: text/vnd.wap.wml; charset=utf-8");

    #header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
    #header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always...

    if (strtoupper($_SERVER['SERVER_PROTOCOL']) == "HTTP/1.0")
	    header("Pragma: no-cache");
    else {	//  assume HTTP/1.1 or later
	if (!$cache)
	    header("Cache-Control: no-store, no-cache, must-revalidate");
	else
	    header("Cache-Control: max-age=$cache, private, proxy-revalidate");
	    
//	header("Cache-Control: post-check=0, pre-check=0", false);
    }


    //  Begin the wml document
    echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
    echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\" \"http://www.wapforum.org/DTD/wml_1.1.xml\">\n\n";

    echo "<wml>\n";

    echo "<head>\n";
    if (!$cache)
	echo "<meta http-equiv=\"Cache-Control\" content=\"no-cache\" forua=\"true\"/>\n";
    else
	echo "<meta http-equiv=\"Cache-Control\" content=\"max-age=$cache\" forua=\"true\"/>\n";
    echo "</head>\n";


    echo "<template><onevent type=\"onenterforward\"><refresh>";
    echo "<setvar name=\"H\" value=\"$H\"/>";
    echo "<setvar name=\"F\" value=\"$F\"/>";
    echo "<setvar name=\"U\" value=\"$U\"/>";
    echo "<setvar name=\"CP\" value=\"$CP\"/>";
    echo "<setvar name=\"S\" value=\"$S\"/>";
    echo "</refresh></onevent></template>\n";
}


function wmlend() {

	echo "</wml>\n";
}


function type2str($type) {

	$str = array("text", "multipart", "message", "application", "audio", "image", "video", "other"); 

	if ($type >= count($str))  return "unknown";
	else  return $str[$type];
} 


function get_link($button,$name,$href,$fields,$post=false,$reload=false) {

	$L = "";

	if ($href[0] == '#') {
	    if (!$button)
		$L .= "<anchor title=\""._('SUBMIT')."\" color=\"#0000ff\">$name";
	    else
		$L .= "<do type=\"accept\" label=\"$name\">";
	
	    $L .= "<go href=\"$href\">";
	    if (!empty($fields)) {
		foreach ($fields as $key => $value)
			$L .= "<setvar name=\"$key\" value=\"$value\"/>";
	    }
	    $L .= "</go>";

	    if (!$button)  $L .= "</anchor>";
	    else  $L .= "</do>\n";
	}
	else {
	    $ST=array("H"=>"\$H","F"=>"\$F","U"=>"\$U","CP"=>"\$CP","S"=>"\$S");
	    $fields = array_merge($ST,(array)$fields);

	    if ($reload) {
		global $S;
		if ($S)  $fields["S"] = $S + 1;
	    }

	    if (!$post) {
		$h = "";
		foreach ($fields as $key => $value) {
		    if (!empty($h))  $h .= "&amp;";
		    if ($value[0] != "$")  $value = rawurlencode($value);
		    $h .= $key . "=" . $value;
		}
		$href .= "?" . $h;

		if (!$button)
		    $L .= "<a title=\""._('SUBMIT')."\" color=\"#0000ff\" href=\"$href\">$name</a>";
		else {
		    $L .= "<do type=\"accept\" label=\"$name\">";
		    $L .= "<go href=\"$href\">";
		    $L .= "</go></do>\n";
		}
	    }
	    else {
		if (!$button)
		    $L .= "<anchor title=\""._('SUBMIT')."\" color=\"#0000ff\">$name";
		else
		    $L .= "<do type=\"accept\" label=\"$name\">";

		$L .= "<go href=\"$href\" method=\"post\">";
		foreach ($fields as $key => $value)
			$L .= "<postfield name=\"$key\" value=\"$value\"/>";
		$L .= "</go>";

		if (!$button)  $L .= "</anchor>";
		else  $L .= "</do>\n";
	    }
	}

	return $L;
}


function wmllink($name,$href,$fields,$post = false) {

	echo  get_link(0,$name,$href,$fields,$post) . "\n";
}

function get_wmllink($name,$href,$fields,$post = false) {

	return  get_link(0,$name,$href,$fields,$post);
}

function wmlbutton($label,$href,$fields,$post = false, $reload = false) {

	echo  get_link(1,$label,$href,$fields,$post,$reload);
}


function resetbutton($label,$fields) {

	echo "<do type=\"reset\" label=\"$label\"><refresh>";
	if (!empty($fields)) {
	    foreach ($fields as $key => $value)
		    echo "<setvar name=\"$key\" value=\"$value\"/>";
	}
	echo "</refresh></do>\n";
}


function need_len($str,$len) {

	if (strlen($str) < $len)  return str_pad($str,$len);
	else  return substr($str,0,$len);
}

function cryptomask($src) {
	global $H,$F,$U,$SECRET;

	if (!empty($SECRET))
		$salt = $SECRET;
	else {
	    /*  some default way, better than nothing...  */
	    $st = stat(dirname($_SERVER['SCRIPT_FILENAME']));
	    $salt = $st['ino'];
	}

	if (CRYPT_MD5)  $salt = "\$1$" . need_len($salt,8) . "\$";
	else  $salt = need_len($salt,2);    //  simple DES ...


	// compute some crypted value, depended on the specific host's
	// SECRET salt, the SERVER_NAME, imap/pop3 server ($H),
	// the folder ($F) and, surely :), the user name ($U)

	$str = $_SERVER['SERVER_NAME']."&".$H."&".$F."&".$U;
	$str = substr(crypt($str, $salt),strlen($salt));
	$str = base64_decode($str);

	$n = strlen($str);
	$pp = str_pad($src,$n,chr(0));
	$cp = array();
	for ($i = 0; $i < $n; $i++)
	    $cp[$i] = $str[$i] ^ $pp[$i];

	for ($i--; $i >= 0; $i--) {
	    if ($cp[$i] == chr(0))  unset($cp[$i]);
	    else  break;
	}

	return implode('',$cp);
}


function wmlspecialchars($text) {

	/*  Note: &amp; must be first!  */
	$text = str_replace(
		    array("&","\"","'","<",">","\$"),
		    array("&amp;","&quot;","&apos;","&lt;","&gt;","$$"),
		    $text);

	return $text;
}


function getheader($string) {

	if (empty($string))  return $string;

	$elements = imap_mime_header_decode($string);
	$string = "";
	while (list($e, $element) = each($elements)) {
	    if($element->charset == "default") {
		if(!iconv("utf-8", "utf-8", $element->text)) {
		    $string .= eregi_replace(".", "?", $element->text);
		} else {
		    $string .= $element->text;
		}
	    }
	    else {
		$string .= iconv($element->charset, "utf-8", $element->text);
	    }
	}
 
	$string = trim(wmlspecialchars($string));
	return $string;
}

function putheader($str) {

	if (ereg("[\x80-\xff]",$str)) {
	    $str = imap_binary($str);
	    $lines = explode("\n",$str);

	    $str = "";
	    foreach($lines as $l) {
		$l = trim($l);
		if (empty($l))  continue;
		$str .= "=?UTF-8?B?" . $l . "?= ";
	    }
	}

	return $str;
}


function get_text($mbox,$uid,$structure,$part) {

	if (!$part)  $part = 1;

	$text = imap_fetchbody($mbox, $uid, $part, FT_UID); 
	if($structure->encoding == ENCBASE64)
		$text = imap_base64($text); 
	else if($structure->encoding == ENCQUOTEDPRINTABLE) {
		$text = imap_qprint($text);
		$text = ereg_replace ("=\r?\n", "", $text);
	} 


	if ($structure->ifparameters) {
	    while (list($index, $object) = each($structure->parameters)) {
		if (strtolower($object->attribute) == "charset") {
		    $charset = $object->value;
		    break;
		}
	    }
	}

	if (!$charset)
		$charset = "utf-8";	//  assume good robust default...
	elseif(!iconv($charset,"utf-8","123"))	// bad charset specified
		$charset = "utf-8";	// assume good solution here...


	if ($structure->ifsubtype &&
	    strtoupper($structure->subtype) == "HTML"
	) {
	    //  strip some tags and convert <br>'s to newlines
	    $text = preg_replace(array("/<head(.|\s)*?>(.|\s)*?<\/head>/i",
					"/<title(.|\s)*?>(.|\s)*?<\/title>/i",
					"/<script(.|\s)*?>(.|\s)*?<\/script>/i",
					"/<style(.|\s)*?>(.|\s)*?<\/style>/i",
					"/<br\/?>/i"),
				 array("","","","","\n"),
				 $text);

	    // strip remaining html tags
	    $text = strip_tags($text);

	    //  convert html-encoded to flat characters...
	    $text = html_entity_decode($text);
	    $text = str_replace("&nbsp;"," ",$text);
	}

	$text = trim($text);	//  to zero space-only message parts...


	//  Now we have a final flat text here. Convert further...

	$text = wmlspecialchars($text);

	$text = preg_replace(
		    array("/([ \t\r]*\n){3,}/",
				"/[ \t\r]*\n/",
				'/([-_=#*])\\1{3,}/'),
		    array("<br/><br/>\n",
				"<br/>\n",
				'\\1\\1\\1\\1'),
		    $text);

	return iconv($charset, "utf-8//IGNORE", $text);
}


function sub_part($parent,$idx) {

	if ($parent)  return  $parent . "." . ($idx + 1);
	else  return ($idx + 1);
}


function get_multipart($mbox,$uid,$structure,$part) {
	global $PAGESIZE;

	if (is_null($structure->parts))
		return false;

	if ($structure->ifsubtype &&
	    strtoupper($structure->subtype) == "ALTERNATIVE"
	) {
	    foreach ($structure->parts as $idx => $sub) {
		if ($sub->type != TYPETEXT)  continue;	    //  not a text
		if (!$sub->ifsubtype)  continue;
		else {
		    $subtype = strtoupper($sub->subtype);
		    if ($subtype == "PLAIN")  $plain = $idx;
		    elseif ($subtype == "HTML")  $html = $idx;
		}
	    }

	    if (isset($plain))  $best = $plain;
	    else if (isset($html))  $best = $html;
	    else  return false;

	    $text = get_text($mbox,$uid,$structure->parts[$best],
						    sub_part($part,$best));

	    if (strlen($text) == 0 && $html)
		$text = get_text($mbox,$uid,$structure->parts[$html],
						    sub_part($part,$html));
	    return $text;
	}


	$text = "";

	foreach ($structure->parts as $idx => $sub) {

	    /*  if text is already big enough, no more inline attachments  */
	    if ($sub->ifdisposition && $sub->ifdparameters &&
		strlen($text) >= $PAGESIZE
	    )  continue;

	    $p = sub_part($part,$idx);

	    if ($sub->type == TYPEMULTIPART) {
		if (ereg("\.[0-9]\.[0-9]\.",$p))
			continue;	//  too big recursion...
		$text .= get_multipart($mbox,$uid,$sub,$p);
	    }
	    elseif ($sub->type == TYPEMESSAGE) {
		/*  do not include too deep rfc822 messages   */
		if ($part)  continue;

		$text .= get_message($mbox,$uid,$sub,$p);
	    }
	    elseif ($sub->type == TYPETEXT) {	//  text
		if (strlen($text) > 0)	//  to separate parts...
			$text .= "<br/>\n<fieldset></fieldset><br/>\n";
		$text .= get_text($mbox,$uid,$sub,$p);
	    } else
		continue;
	}

	return $text;
}


function get_message($mbox,$uid,$structure,$part) {

	if (is_null($structure->parts))
		return false;

	if ($structure->type == TYPEMESSAGE &&		//  a message...
	    count($structure->parts) == 1 &&		//  ...has one...
	    $structure->parts[0]->type == TYPEMULTIPART	//  ...multipart
	)  $structure = $structure->parts[0];

	return  get_multipart($mbox,$uid,$structure,$part);
}


function part2sub($structure,$part) {

	$p = explode(".",$part);

	for ($i = 0, $sub = $structure; $i < count($p); $i++) {

	    if ($sub->type == TYPEMESSAGE &&		//  message has...
		count($sub->parts) == 1 &&		//  ...single...
		$sub->parts[0]->type == TYPEMULTIPART	//  ...multipart
	    )  $sub = $sub->parts[0];

	    $idx = $p[$i] - 1;
	    if ($idx >= count($sub->parts))  return false;
	    $sub = $sub->parts[$idx];
	}

	return $sub;
}


function getmsgbody($mbox,$uid,$structure,$part) {

	/*  check whether an attachment required  */
	if ($part) {
	    $structure = part2sub($structure,$part);
	    if (!$structure)  return false;
	}

	if ($structure->type == TYPETEXT)
	    $text = get_text($mbox,$uid,$structure,$part);
	elseif ($structure->type == TYPEMULTIPART)
	    $text = get_multipart($mbox,$uid,$structure,$part);
	elseif ($structure->type == TYPEMESSAGE)
		$text = get_message($mbox,$uid,$structure,$part);
	else
	    return false;

	return $text;
}


/*  extract subject from the raw headers (for nested message/rfc822 etc...)  */

function extract_subject($string) {

    $string = preg_replace("/\r?\n[ \t]+/"," ",$string);

    $lines = explode("\n",$string);
    foreach($lines as $line) {
	if (eregi("^subject:",$line))
	    return  getheader(eregi_replace("^subject: *","",$line));
    }

    return "(No subject)";
}


class Attachment {
	var $name;
	var $bytes;
	var $part;
	var $type;
	var $subtype;
};

function get_att($mbox,$uid,$structure,$part) {

	if (count($structure->parts) == 0)
		return NULL;

	$attaches = array();
	$a = 0;

	foreach ($structure->parts as $idx => $sub) {

	    $p = sub_part($part,$idx);

	    if ($sub->type == TYPEMESSAGE) {
		//  add the message itself...
		$n = extract_subject(imap_fetchbody($mbox,$uid,$p.".0",FT_UID));

		$att = new Attachment();
		$att->name = $n . ".eml";
		$att->bytes = $sub->bytes;
		$att->part = $p;
		$att->type = $sub->type;
		if ($sub->ifsubtype)  $att->subtype = strtolower($sub->subtype);
		$attaches[$a++] = $att;

		//  if has single multipart only...
		if (count($sub->parts) == 1 &&
		    $sub->parts[0]->type == TYPEMULTIPART
		)  $sub = $sub->parts[0];
	    }

	    if (count($sub->parts) > 0) {   //  multipart, message
		if (ereg("\.[0-9]\.[0-9]\.",$p))
			continue;	//  too big recursion...

		$att = get_att($mbox,$uid,$sub,$p);
		if (count($att) > 0) {
		    $attaches = array_merge($attaches,$att);
		    $a = count($attaches);
		}
	    }
	    elseif ($sub->ifdisposition && $sub->ifdparameters) {
		$name = getheader($sub->dparameters[0]->value);

		$att = new Attachment();
		$att->name = $name;
		$att->bytes = $sub->bytes;
		if ($sub->encoding == ENCBASE64)
			$att->bytes = ceil(($sub->bytes * 3) / 4);
		$att->part = $p;
		$att->type = $sub->type;
		if ($sub->ifsubtype)  $att->subtype = strtolower($sub->subtype);

		$attaches[$a++] = $att;
	    }
	}

	return $attaches;
}


function getattaches($mbox,$uid,$structure) {

	return  get_att($mbox,$uid,$structure,0);
}


function  wmldie($string) {

	wmlstart();
	echo "<card><p><b>Server Error:</b> $string <br/></p></card>\n";
	wmlend();
	die();
}

?>
